component-section
  div(slot='title') 🕸️ Grafen
  component-section
    div(slot='title') Waarom je over grafen leert
    p
      | Grafen zijn veruit de flexibelste en breedst toepasbare adt’s die er zijn.
      | Afhankelijk van wat voor type graaf je bedoelt kunnen de eigenschappen van de mogelijke graaf-datastructuren erg verschillen.
      | Deze verschillen zijn echter allemaal wiskundig te modelleren, en ook buiten de informatica wordt dat veelvuldig gedaan.
    p.praktijk Routeplanners zijn afhankelijk van grafen.
    p.praktijk
      | Je hebt al met Maven gewerkt.
      | Net als andere package managers gebruikt Maven een graaf om afhankelijkheden tussen softwaremodules uit te rekenen.
  component-section
    div(slot='title') Grafen
    p
      | OpenDSA heeft een uitstekende samenvatting van basale grafentheorie, inclusief demo’s.
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/GraphIntro.html') 14.1. Graphs Chapter Introduction
    p
      | Er zijn twee belangrijkste manieren om een graaf als datastructuur te implementeren, namelijk een
      |
      em.term adjacency list
      |
      | en een
      |
      em.term adjacency matrix
      | .
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/GraphImpl.html') 14.2. Graph Implementations
    p
      | In het Nederlands noemen we een
      |
      em.term vertex
      |
      | een
      |
      em.term punt
      |
      | en een
      |
      em.term edge
      |
      | een
      |
      em.term lijn
      | . Een
      |
      em.term path
      |
      | is gewoon een
      |
      em.term pad
      | .
    p
      | Voor een visuele uitleg, en om je Brits-Engels te trainen 😁, bekijk je Kevin Drumm’s video.
    p.bron Graph Data Structure 1. Terminology and Representation (algorithms)
    component-video(videoid='c8P9kB1eun4', title='Graph Data Structure 1. Terminology and Representation (algorithms)')
  component-section
    div(slot='title') Dijkstra’s algoritme voor kortste paden
    p
      | Er zijn twee standaardmanieren om een graaf
      |
      em.term af te lopen
      |
      | (
      em.term traverse, traversal
      | ):
      |
      em.term breadth-first
      |
      | en
      |
      em.term depth-first
      | .
      | Dat doe je meestal op zoek naar iets specifieks, zoals een punt met een bepaalde waarde, dus dan heet dit search (met afkortingen
      |
      em.term BFS
      |
      | voor breadth-first search en
      |
      em.term DFS
      |
      | voor depth-first search).
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/GraphTraversal.html') 14.3. Graph Traversals
    component-section
      div(slot='title')
        a(href='https://ans.app/digital_test/assignments/297639/routing') BFS versus DFS (op Ans)
      component-exercise
    component-section
      div(slot='title') Single-source shortest paths
      p
        | Er zijn manieren om een search vanuit één punt \(a\) naar alle andere punten \(v \in V\) te doen, en daarbij te bepalen hoeveel gewicht ieder pad \(a → v\) heeft.
        | Het standaardalgoritme hiervoor is
        em.term Dijkstra’s kortstepadenalgoritme vanuit één punt
        | .
        | Als de graaf
        |
        em.term gewogen
        |
        | is, heeft iedere lijn een eigen gewicht.
        | Als het daarentegen een
        |
        em.term ongewogen
        |
        | graaf is, kan je het gewicht op \(1\) stellen.
        | In dat geval loopt het algoritme de graaf af als een BFS.
      p OpenDSA legt het algoritme uit, en hoe je dit zou kunnen implementeren in Java
      p.extra
        | Het stuk in deze bron over implementatie met een
        |
        em min-heap
        | -datastructuur is extra.
      p.bron
        a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/GraphShortest.html') 14.5. Shortest-Paths Problems
      p.bron Graph Data Structure 4. Dijkstra’s Shortest Path Algorithm
      component-video(videoid='pVfj6mxhdMw', title='Graph Data Structure 4. Dijkstra’s Shortest Path Algorithm')
      p
        | Trouwens, als twee afstanden gelijk zijn en je wilt de volgende node kiezen, dan kan je vertrouwen op de werking van de
        |
        code dequeue
        | -operatie van de priority queue die je (eventueel in je hoofd) gebruikt.
        | Zelfs als punten dezelfde prioriteit hebben, dan zijn ze in een bepaalde volgorde ge-
        code enqueue
        | d en zal je ze op die volgorde weer
        |
        code dequeue
        | n.
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297643/routing') Dijkstra’s kortstepadenalgoritme bij negatieve gewichten (op Ans)
        component-exercise
    component-section(extra='')
      div(slot='title') All-pairs shortest paths
      p
        | Dijkstra’s algoritme is te generaliseren tot een algo dat de kortste paden tussen élk punt vindt.
      p.bron
        a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/Floyd.html') 14.8. All-Pairs Shortest Paths
      p.bron Graph Data Structure 4. Dijkstra’s Shortest Path Algorithm
